﻿$(document).ready(function () {
    setVisibilityForApprovalType();
    loadConfigurationItems();

    $(".approvalInitiator").change(function () {
        setVisibilityForApprovalType();
    });

    $("#CustomFormId").change(function () {
        loadCustomFormField();
    });

    $("#CustomFormFieldId").change(function () {
        loadCustomFormFieldItem();
    });

    $("#SelectedInventoryCategory").change(function () {
        loadConfigurationItems();
    });
});

function loadConfigurationItems() {
    if ($("#SelectedInventoryCategory").val() != "") {
        OnAjaxBegin(Localization_ApprovalManagement_LoadingItems);
        if (selectedInventoryConfigurationItems == null) { //nastane když je null v db
            selectedInventoryConfigurationItems = new Array();
        }
        $("#TdInventoryConfigurationItems").load(RQ_URL + "/ApprovalManagement/GetConfigurationItems/" + $("#SelectedInventoryCategory").val() + "?selectedConfigurationItem=" + selectedInventoryConfigurationItems.join(","), function () {
            $("#SelectedInventoryConfigurationItems").val(selectedInventoryConfigurationItems).trigger("change");
            selectedInventoryConfigurationItems = null;
            OnAjaxComplete();
        });
    }
}

function loadCustomFormField() {
    if ($("#CustomFormId").val() != "") {
        OnAjaxBegin(Localization_ApprovalManagement_LoadingArray);
        $.ajax({
            url: RQ_URL + "/ApprovalManagement/GetCustomFormFields",
            type: "POST",
            data: JSON.stringify({
                id: $("#CustomFormId").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                $("#CustomFormFieldId").empty();
                $("#CustomFormFieldId").append("<option selected='selected' value>" + Localization_ApprovalManagement_PleaseSelect + "</option>")
                $.each(g, function (index, value) {
                    $("#CustomFormFieldId").append("<option value='" + value.Id + "'>" + value.Name + "</option>");
                });
                $("#CustomFormFieldId").trigger("change");
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
                OnAjaxComplete();
            }
        });
    }
    $("#CustomFormFieldId").empty();
    $("#CustomFormFieldId").append("<option selected='selected' value>" + Localization_ApprovalManagement_PleaseSelect + "</option>").trigger("change");
}

function loadCustomFormFieldItem() {
    if ($("#CustomFormFieldId").val() != "") {
        OnAjaxBegin(Localization_ApprovalManagement_LoadingArray);
        $.ajax({
            url: RQ_URL + "/ApprovalManagement/GetCustomFormFieldItems",
            type: "POST",
            data: JSON.stringify({
                id: $("#CustomFormFieldId").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                
                $("#CustomFormFieldItemIds").empty();
                $.each(g, function (index, value) {
                    $("#CustomFormFieldItemIds").append("<option value='" + value.Id + "'>" + value.Name + "</option>");
                });
                $("#CustomFormFieldItemIds").trigger("change");
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
                OnAjaxComplete();
            }
        });
    }
    $("#CustomFormFieldItemIds").empty().trigger("change");
}

function setVisibilityForApprovalType() {
    if ($("#ApprovalInitiatorTypeAndService").is(':checked')) {
        $(".customFormFieldItem").hide(); 
        $(".inventoryConfigurationItem").hide();
        $(".typeAndService").show();
    }
    else if ($("#ApprovalInitiatorInventoryConfigurationItem").is(':checked')) {
        $(".typeAndService").hide();
        $(".customFormFieldItem").hide();
        $(".inventoryConfigurationItem").show();
    }
    else {
        $(".typeAndService").hide();
        $(".inventoryConfigurationItem").hide();
        $(".customFormFieldItem").show();
    }
}