﻿var selectedProductItemUserIds = Array();
var selectedProductItemCustomerIds = Array();
var yesOrNoFillter = ";False:" + "" + Localization_Yes + ";True:" + Localization_No; //pole má otečené zobraznení proto je ano = False

$(document).ready(function () {
    $("#dialog-add-product-item").dialog({
        autoOpen: false,
        modal: true,
        width: 800,
        buttons: [{
            text: Localization_Save,
            id: "DialogAddProductItemSave",
            click: function () {
                $("#SaveProductItem").submit();
            },
        },
        {
            text: Localization_Cancel,
            click: function () {
                $("#dialog-add-product-item").dialog("close");
            }
        }]
    });

    $("#jqGridProductItemUsersList").jqGrid({
        url: RQ_URL + '/Products/ProductItemsUserListData/' + productId,
        mtype: "POST",
        styleUI: 'Bootstrap',
        datatype: "json",
        autoencode: true,
        colModel: [
            { name: 'Id', key: true, hidden: true },
            { label: ' ', name: 'Avatar', formatter: formatAvatar, width: 55, fixed: true, search: false, sortable: false },
            { label: Localization_ProductUser, name: 'FullName', width: 150, search: true, sortable: true, formatter: userFormat },
            { label: Localization_ProductDescription, name: 'Description', width: 150, search: false, sortable: false },
            { label: Localization_ProductCustomField, name: "customFields", width: 150, formatter: productItemCustomFieldsFormatter, search: false, sortable: false },
            { label: Localization_ProductActive, name: 'IsActive', formatter: isActiveUserFormatter, width: 70, stype: 'select', searchoptions: { sopt: ['eq'], value: ':' + Localization_All_Short + yesOrNoFillter } },
            { label: Localization_Actions, name: "actions", width: 80, fixed: true, formatter: formatActionsUsers, search: false, sortable: false, title: false },
        ],
        shrinkToFit: true,
        multiselectWidth: 60,
        multiselect: true,
        sortname: 'FullName',
        sortorder: "asc",
        autowidth: true,
        height: 'auto',
        rowNum: 20,
        scrollOffset: 0,
        rowList: [10, 20, 50, 100, 200],
        viewrecords: true,
        pager: "#jqGridProductItemUsersListPager",
        loadError: function (xhr, st, err) {
            alert("Type: " + st + "; Response: " + xhr.status + " " + xhr.statusText);
        },
        loadComplete: function (data) {
            $(".number-of-users").text(data.records);
            initBootstrapUserMini();
        },
        onSelectRow: function (id, isSelected) {
            SelectRowUserEvent(id, isSelected);
        },
        onSelectAll: function (id, isSelected) {
            for (i = 0; i < id.length; i++) {
                SelectRowUserEvent(id[i], isSelected)
            };
        },
    });

    $("#jqGridProductItemUsersList").setGridWidth($(".nav")[0].offsetWidth);
    $("#jqGridProductItemUsersList").filterToolbar({
        autoSearch: true,
        stringResult: true, //musi byt bud toto, nebo searchOperators, jinak se neposle vlastnost filters
        searchOnEnter: true,
        //searchOperators: true,
    });

    $('#jqGridProductItemUsersList').on("click", ".deleteLink", function (e) {
        e.preventDefault();
        var id = $(this).closest('tr.jqgrow').attr("id");

        $("#dialog-delete-confirm").dialog({
            autoOpen: true,
            modal: true,
            buttons: [{
                text: Localization_Yes,
                click: function () {
                    $.post(
                        RQ_URL + '/Products/DeleteProductItem',
                        { id: id },
                        function (data) {
                            if (data.Success) {
                                ShowSuccess(data.Message);
                                $("#jqGridProductItemUsersList").trigger('reloadGrid');
                            }
                            else
                                ShowError(data.Message);
                        },
                        "json"
                    )
                        .always(function () { $("#dialog-delete-confirm").dialog("close"); })
                        .fail(function (error) { alert(error.responseText); })
                        .done(function () {
                        });
                }
            }, {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }]
        });
    });

    $("#jqGridProductItemCustomersList").jqGrid({
        url: RQ_URL + '/Products/ProductItemsCustomerListData/' + productId,
        mtype: "POST",
        styleUI: 'Bootstrap',
        datatype: "json",
        autoencode: true,
        colModel: [
            { name: 'Id', key: true, hidden: true },
            { label: ' ', name: 'HasCustomerImage', formatter: logoFormatter, search: false, fixed: true, width: 100, classes: "right" },
            { label: Localization_ProductCompany, name: 'CustomerName', width: 150, search: true, sortable: true, formatter: companyFormatter },
            { label: Localization_ProductDescription, name: 'Description', width: 150, search: false, sortable: false },
            { label: Localization_ProductCustomField, name: "customFields", width: 150, formatter: productItemCustomFieldsFormatter, search: false, sortable: false },
            { label: Localization_ProductActive, name: 'IsActive', formatter: isActiveCustomerFormatter, width: 70, stype: 'select', searchoptions: { sopt: ['eq'], value: ':' + Localization_All_Short + yesOrNoFillter } },
            { label: Localization_Actions, name: "actions", width: 80, fixed: true, formatter: formatActionsCustomers, search: false, sortable: false, title: false },
        ],
        shrinkToFit: true,
        multiselectWidth: 60,
        multiselect: true,
        sortname: 'CustomerName',
        sortorder: "asc",
        autowidth: true,
        height: 'auto',
        rowNum: 20,
        scrollOffset: 0,
        rowList: [10, 20, 50, 100, 200],
        viewrecords: true,
        pager: "#jqGridProductItemCustomersListPager",
        loadError: function (xhr, st, err) {
            alert("Type: " + st + "; Response: " + xhr.status + " " + xhr.statusText);
        },
        loadComplete: function (data) {
            $(".number-of-customers").text(data.records);
            initBootstrapCustomerMini();
        },
        onSelectRow: function (id, isSelected) {
            SelectRowCustomerEvent(id, isSelected);
        },
        onSelectAll: function (id, isSelected) {
            for (i = 0; i < id.length; i++) {
                SelectRowCustomerEvent(id[i], isSelected)
            };
        },
    });

    $("#jqGridProductItemCustomersList").setGridWidth($(".nav")[0].offsetWidth);
    $("#jqGridProductItemCustomersList").filterToolbar({
        autoSearch: true,
        stringResult: true, //musi byt bud toto, nebo searchOperators, jinak se neposle vlastnost filters
        searchOnEnter: true,
        //searchOperators: true,
    });

    $('#jqGridProductItemCustomersList').on("click", ".deleteLink", function (e) {
        e.preventDefault();
        var id = $(this).closest('tr.jqgrow').attr("id");

        $("#dialog-delete-confirm").dialog({
            autoOpen: true,
            modal: true,
            buttons: [{
                text: Localization_Yes,
                click: function () {
                    $.post(
                        RQ_URL + '/Products/DeleteProductItem',
                        { id: id },
                        function (data) {
                            if (data.Success) {
                                ShowSuccess(data.Message);
                                $("#jqGridProductItemCustomersList").trigger('reloadGrid');
                            }
                            else
                                ShowError(data.Message);
                        },
                        "json"
                    )
                        .always(function () { $("#dialog-delete-confirm").dialog("close"); })
                        .fail(function (error) { alert(error.responseText); })
                        .done(function () {
                        });
                }
            }, {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }]
        });
    });

    if (openItemId != null) {
        if (openCustomerDialog) {
            showDialogEditCustomer(openItemId);
        } else {
            showDialogEditUser(openItemId);
        }
    }
    if (openNewDialog) {
        if (openCustomerDialog) {
            showDialogAddCustomer(customerId);
        } else {
            showDialogAddUser(userProviderKey);
        }
    }
});

function saveProductGeneral() {
    $("#SaveProduct").submit();
}

function OnSaveProductAjaxSuccess(data) {
    if (data.result.Success) {
        ShowSuccess(Localization_ProductWasSaved);
        refreshToolbar();
    }
    else {
        $("#SaveProduct").html(data.html); //some form errors, redisplay form
    }
}

function refreshToolbar() {
    $("#EditProductToolbar").html("<div class='loading-32'></div >");
    $("#EditProductToolbar").load(RQ_URL + "/Products/ReloadToolbar/" + productId,
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
        });
}

function OnSaveProductItemAjaxSuccess(data) {
    if (data.result.Success) {
        ShowSuccess(Localization_ProductItemWasSaved);
        $("#dialog-add-product-item").dialog("close");
        $("#jqGridProductItemUsersList").trigger('reloadGrid');
        $("#jqGridProductItemCustomersList").trigger('reloadGrid');
    }
    else {
        $("#dialog-add-product-item").html(data.html); //some form errors, redisplay form
    }
}

function formatActionsCustomers(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_CreatingPdf + "' href='" + RQ_URL + "/Products/ExportProductItemToPdf/" + rowObject.Id + "'><i class=\"far fa-file-pdf fa-lg fa-fw\"></i></a>";
    actionHtml += "<a data-toggle='tooltip' title='" + Localization_Edit + "' class='editLink jqgrid-bootstrap-table-edit' href='javascript:showDialogEditCustomer(" + rowObject.Id + ")'><i class=\"fa fa-pencil-square-o fa-lg fa-fw\"></i></a>";
    actionHtml += "<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete + "' href='javascript:void(0);'><i class=\"fa fa-trash-o fa-lg fa-fw\"></i></a>";
    return actionHtml;
}

function formatActionsUsers(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_CreatingPdf + "' href='" + RQ_URL + "/Products/ExportProductItemToPdf/" + rowObject.Id + "'><i class=\"far fa-file-pdf fa-lg fa-fw\"></i></a>";
    actionHtml += "<a data-toggle='tooltip' title='" + Localization_Edit + "' class='editLink jqgrid-bootstrap-table-edit' href='javascript:showDialogEditUser(" + rowObject.Id + ")'><i class=\"fa fa-pencil-square-o fa-lg fa-fw\"></i></a>";
    actionHtml += "<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete + "' href='javascript:void(0);'><i class=\"fa fa-trash-o fa-lg fa-fw\"></i></a>";
    return actionHtml;
}

function showDialogAddCustomer(customerId) {
    $("#dialog-add-product-item").dialog('option', 'title', Localization_ProductCompany);
    $("#dialog-add-product-item").html("<div class='loading-32'></div>");
    $("#dialog-add-product-item").dialog("open");
    $("#DialogAddProductItemSave").text(Localization_Create);
    $("#dialog-add-product-item").load(RQ_URL + "/Products/LoadProductItemDialog/" + productId + "?type=Customer&customerId=" + customerId,
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            $("#dialog-add-product-item").dialog("close");
            $("#dialog-add-product-item").dialog("open");
            initProductItemDialog();
        });
}

function showDialogAddUser(userProviderKey) {
    $("#dialog-add-product-item").dialog('option', 'title', Localization_ProductUser);
    $("#dialog-add-product-item").html("<div class='loading-32'></div>");
    $("#dialog-add-product-item").dialog("open");
    $("#DialogAddProductItemSave").text(Localization_Create);
    var loadUrl = RQ_URL + "/Products/LoadProductItemDialog/" + productId + "?type=User";
    if (userProviderKey != null) {
        loadUrl += "&userProviderKey=" + userProviderKey;
    }
    $("#dialog-add-product-item").load(loadUrl,
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            $("#dialog-add-product-item").dialog("close");
            $("#dialog-add-product-item").dialog("open");
            initProductItemDialog();
        });
}

function showDialogEditCustomer(id) {
    $("#dialog-add-product-item").dialog('option', 'title', Localization_ProductCompany);
    $("#dialog-add-product-item").html("<div class='loading-32'></div>");
    $("#dialog-add-product-item").dialog("open");
    $("#DialogAddProductItemSave").text(Localization_Save);
    $("#dialog-add-product-item").load(RQ_URL + "/Products/LoadProductItemDialog/" + productId + "?type=Customer&productItemId=" + id,
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            $("#dialog-add-product-item").dialog("close");
            $("#dialog-add-product-item").dialog("open");
            initProductItemDialog();
        });
}

function showDialogEditUser(id) {
    $("#dialog-add-product-item").dialog('option', 'title', Localization_ProductUser);
    $("#dialog-add-product-item").html("<div class='loading-32'></div>");
    $("#dialog-add-product-item").dialog("open");
    $("#DialogAddProductItemSave").text(Localization_Save);
    $("#dialog-add-product-item").load(RQ_URL + "/Products/LoadProductItemDialog/" + productId + "?type=User&productItemId=" + id,
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            $("#dialog-add-product-item").dialog("close");
            $("#dialog-add-product-item").dialog("open");
            initProductItemDialog();
        });
}

function initProductItemDialog()
{
    SearchableCombos();
    $(".date-picker-product").datepicker();
}

function logoFormatter(cellValue, options, rowObject) {
    return cellValue == false ? "<i class='fa fa-building-o fa-2x' ></i>" : "<img src='" + RQ_URL + "/Customers/GetIcon/" + rowObject.CustomerId + "' />";
}

function userFormat(cellValue, options, rowObject) {
    return "<a href='" + RQ_URL + "/Customers/User/" + rowObject.UserProviderKey + "'>" + htmlEncode(cellValue) + "</a>";
}

function companyFormatter(cellValue, options, rowObject) {
    return cellValue != null ? "<a href='" + RQ_URL + "/Customers/Edit/" + rowObject.CustomerId + "'>" + htmlEncode(cellValue) + "</a>" : "";
}

function SelectRowUserEvent(id, isSelected) {
    if (isSelected) {
        //item selected, add index to array
        if (selectedProductItemUserIds.indexOf(Number(id)) == -1) {
            selectedProductItemUserIds.push(Number(id));
        }
    }
    else {
        //item deselected, remove from array
        var index = selectedProductItemUserIds.indexOf(Number(id))

        if (index != -1) {
            selectedProductItemUserIds.splice(index, 1);
        }
    }
    refreshBulkActionButtonsAndLabels();
}

function refreshBulkActionButtonsAndLabels() {
    if ($("#TotalNumberOfUsersRows").length > 0) {
        $("#TotalNumberOfUsersRows").text("(" + selectedProductItemUserIds.length + ")");
    } else {
        $("#jqgh_jqGridProductItemUsersList_cb").append("<span id='TotalNumberOfUsersRows'>(" + selectedProductItemUserIds.length + ")</span>");
    }
    if (selectedProductItemUserIds.length == 0 && $("#TotalNumberOfUsersRows").length > 0) {
        $("#TotalNumberOfUsersRows").remove();
    }
}

function csvUser() {
    window.location.href = RQ_URL + "/Products/ExportProductItemsUserToCsv?productId=" + productId + (selectedProductItemUserIds.length > 0 ? "&ids=" + selectedProductItemUserIds.join(",") : "");
}

function SelectRowCustomerEvent(id, isSelected) {
    if (isSelected) {
        //item selected, add index to array
        if (selectedProductItemCustomerIds.indexOf(Number(id)) == -1) {
            selectedProductItemCustomerIds.push(Number(id));
        }
    }
    else {
        //item deselected, remove from array
        var index = selectedProductItemCustomerIds.indexOf(Number(id))

        if (index != -1) {
            selectedProductItemCustomerIds.splice(index, 1);
        }
    }
    refreshBulkActionButtonsAndLabels();
}

function refreshBulkActionButtonsAndLabels() {
    if ($("#TotalNumberOfCustomersRows").length > 0) {
        $("#TotalNumberOfCustomersRows").text("(" + selectedProductItemCustomerIds.length + ")");
    } else {
        $("#jqgh_jqGridProductItemUsersList_cb").append("<span id='TotalNumberOfCustomersRows'>(" + selectedProductItemCustomerIds.length + ")</span>");
    }
    if (selectedProductItemCustomerIds.length == 0 && $("#TotalNumberOfCustomersRows").length > 0) {
        $("#TotalNumberOfCustomersRows").remove();
    }
}

function csvCustomer() {
    window.location.href = RQ_URL + "/Products/ExportProductItemsCustomerToCsv?productId=" + productId + (selectedProductItemCustomerIds.length > 0 ? "&ids=" + selectedProductItemCustomerIds.join(",") : "");
}

function isActiveUserFormatter(cellValue, options, rowObject) {
    return cellValue != null ? "<input data-id='" + rowObject.Id + "' class='bootstrap-switch-mini-user js-is-active' type='checkbox' " + (cellValue ? "checked='checked'" : "") + ">" : "";
}

function formatAvatar(cellValue, options, rowObject) {
    return cellValue;
}

function isActiveCustomerFormatter(cellValue, options, rowObject) {
    return cellValue != null ? "<input data-id='" + rowObject.Id + "' class='bootstrap-switch-mini-customer js-is-active' type='checkbox' " + (cellValue ? "checked='checked'" : "") + ">" : "";
}

function initBootstrapUserMini() {
    initBootstrap(".bootstrap-switch-mini-user");
}

function initBootstrapCustomerMini() {
    initBootstrap(".bootstrap-switch-mini-customer");
}

function initBootstrap(selector) {
    $(selector).bootstrapSwitch({ size: "mini" });
    $(selector).on('switchChange.bootstrapSwitch', function (event, state) {
        var id = $(this).closest("td").find(".js-is-active").data("id");
        $.post(
            RQ_URL + "/Products/ProductItemActive",
            {
                id: id,
                active: $(this).closest("td").find(".js-is-active").is(":checked"),
            },
            function (data) {
            },
            "json"
        )
            .fail(function (error) { alert(error.responseText); })
            .done(function () { });
    });
}